property VersioneRichiesta : "2.0.3"
property PausaC : 1 -- se si preferiscono dialoghi pi lenti (leggibili) portare questo tempo di pausa a 3/4 secondi
property PausaL : 30 -- se si desidera  possibile portare il timeout a 100 secondi, ma possiamo fare pi bella figura se in 30 secondi liberiamo il computer

global ContaElemento

tell application "iTunes"
	activate
	try
		set MostraDialogo to false -- cambiare a true
		-- se si desiderano dialoghi di conferma al cambio dei nomi delle tracce
		
		-- controllo versione iTunes
		set QuestaVersione to version as string
		if QuestaVersione is not greater than or equal to VersioneRichiesta then
			beep
			display dialog "Questo script richiede iTunes versione " & VersioneRichiesta & 
				return & return & "Versione corrente di iTunes: " & QuestaVersione buttons 
				{"Aggiorna", "Annulla"} default button 2 with icon 2
			if button returned of result is "Aggiorna" then
				my AccessoSitoWeb("http://www.apple.com/itunes/download/")
				return "versione minore"
			end if
		end if
		
		-- ottiene la lista dei riferimenti alle tracce selezionate
		set QuesteTracce to selection of browser window 1
		if QuesteTracce is {} then error "Nessuna traccia  stata selezionata nella finestra corrente."
		
		set SettaggioOriginale to fixed indexing
		set fixed indexing to true
		
		set ContoTracce to count of QuesteTracce
		
		if ContoTracce = 1 then
			set DialogoTracce to " in elaborazione " & (ContoTracce as string) & " traccia."
		else
			set DialogoTracce to "Sono in elaborazione " & (ContoTracce as string) & " tracce."
		end if
		if button returned of (display dialog DialogoTracce & return & return & 
			"Attendere prego" buttons {"  Dettagli  ", "   "} default button 2 giving up after 
			PausaC) is equal to "  Dettagli  " then set MostraDialogo to true
		
		set ContaElemento to 0
		if MostraDialogo then
			-- qui andr inserita in seguito una formula per analizzare il testo per nomi propri e articoli
			if button returned of 
				(display dialog "Ci sono 'nomi propri' nelle tracce selezionate?" & return & return & 
					"(esempio: Lisa, Washington, Maria, Roma, ecc.)" & return & return & 
					"Mostrare un dialogo di conferma prima di ogni modifica?" & return & return 
					buttons {"  Mostra  ", "  Arrangiati  "} giving up after PausaL) 
					is "  Arrangiati  " then set MostraDialogo to false
		end if
		repeat with QuestaTraccia in QuesteTracce
			set ContaElemento to ContaElemento + 1
			set QuestoNome to name of QuestaTraccia
			set {NuovoNome, ModificaEffettuata} to my CambiaMinuscoleMaiuscole(QuestoNome)
			if ModificaEffettuata then
				if MostraDialogo then
					if button returned of (display dialog "Questa operazione non pu essere annullata." & 
						return & return & "Sostituire " & (QuestoNome as string) & 
						" con:" & return default answer NuovoNome buttons 
						{"  Ripristina  ", "  Procedi  "}) is equal to "  Procedi  " then
						set NuovoNome to text returned of Risultato
					else
						set NuovoNome to QuestoNome
						if ContaElemento > 0 and ContoTracce is not equal to 1 then 
							set ContaElemento to ContaElemento - 1
					end if
				end if
				set name of QuestaTraccia to NuovoNome
			else
				if MostraDialogo then display dialog QuestoNome & return & return & "La Traccia " & NuovoNome & 
					" non contiene maiuscole!" buttons {"   "} default button 1 giving up after PausaC
				if ContaElemento > 0 and ContoTracce is not equal to 1 then set ContaElemento to ContaElemento - 1
			end if
		end repeat
		
		set fixed indexing to SettaggioOriginale
		if ContaElemento = 1 then
			set DialogoElementi to (ContaElemento as string) & " nome cambiato "
		else
			set DialogoElementi to (ContaElemento as string) & " nomi cambiati "
		end if
		
		if ContoTracce = 1 then
			set DialogoTracce to "per la " & (ContoTracce as string) & " traccia selezionata."
		else
			set DialogoTracce to "nelle " & (ContoTracce as string) & " tracce selezionate."
		end if
		
		display dialog "Processo completato." & return & return & 
			DialogoElementi & DialogoTracce buttons {"   "} default button 1 giving up after PausaC
		
	on error MessaggioErrore number NumeroErrore
		if NumeroErrore is not -128 then
			beep
			display dialog QuestoNome & return & return & 
				MessaggioErrore buttons {"Annulla"} default button 1
		end if
	end try
end tell

on CambiaMinuscoleMaiuscole(QuestoTesto)
	set Comparazione to "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	set Risorsa to "abcdefghijklmnopqrstuvwxyz"
	set NuovoTesto to ""
	set Modifica to {}
	set Modificata to false
	repeat with QuestoCarattere in QuestoTesto
		set X to offset of QuestoCarattere in Comparazione
		if X is not 0 then
			set NuovoTesto to (NuovoTesto & character X of Risorsa) as string
			set Modifica to Modifica & true
		else
			set NuovoTesto to (NuovoTesto & QuestoCarattere) as string
			set Modifica to Modifica & false
		end if
	end repeat
	if Modifica contains true then set Modificata to true
	return {NuovoTesto, Modificata}
end CambiaMinuscoleMaiuscole

on AccessoSitoWeb(this_URL)
	ignoring application responses
		tell application "Finder"
			open location this_URL
		end tell
	end ignoring
end AccessoSitoWeb